const stylePage = `
html{
  display:flex;
}
body{
  line-height:21pt;
  margin:auto;
}
[data-orientation="portrait"] {
  min-height:257mm;
  padding:20mm 10mm 20mm 20mm;
  background-color:white;
  margin-bottom:32px;
}
[data-orientation="landscape"] {
  padding:10mm;
  min-height: 190mm;
  background-color:white;
  margin-bottom:32px;
}
figure{
  margin-bottom: 0;
}

.signature img {
  width:auto;
}

.table-header{
}
.table-body{
}
.table-header .table-row .table-cell{
  border-top:1px solid black;
}
.table-row{
  display:flex;
  border-left:1px solid black;
  width:auto;
}
.table-cell{
  display:flex;
  align-items:center;
  vertical-align:center;
  border-right:1px solid black;
  border-bottom:1px solid black;
  padding:2px;
  flex-shrink:0;
  flex-grow:0;
}
.table-cell .location{
  word-break:break-word;
}
`

export const replaceStyle = (docHtml: string): string => (
  docHtml
    .replaceAll(/(font-size|line-height|min-height):(| )(\d+|\d+.\d+)px/g, (match) => match.replace('px', 'pt'))
    .replace('</style>', stylePage + ' </style>')
    .replaceAll('min-height: 20.72pt', 'min-height:21pt')
    .replaceAll('[data-orientation="portrait"] div','[data-orientation="portrait"] div:not(.table-cell,.table-row),[data-orientation="portrait"] not(.table-cell) span')
    // подписант
    .replaceAll('<i style="white-space: nowrap"','<i')
    // ссылки
    .replaceAll(`style="font-size: 14pt; font-family: 'Times New Roman'; font-weight: normal"`, `style="color: 1A65DA;" target=”_blank”`)
    .replaceAll(`style="white-space: nowrap; font-size: 14pt; font-family: 'Times New Roman'; font-weight: normal"`, `style="color: 1A65DA;"`)
)